diff --git a/miniupnpd/miniupnpd.c b/miniupnpd/miniupnpd.c
index 625b5e64..74911a6e 100644
--- a/miniupnpd/miniupnpd.c
+++ b/miniupnpd/miniupnpd.c
@@ -2081,6 +2081,18 @@ main(int argc, char * * argv)
 	tomato_helper();
 #endif
 
+#ifdef ENABLE_PCP
+	if(GETFLAG(ENABLENATPMPMASK))
+	{
+		/* Send PCP startup announcements */
+#ifdef ENABLE_IPV6
+		PCPSendUnsolicitedAnnounce(snatpmp, addr_count, spcp_v6);
+#else /* IPv4 only */
+		PCPSendUnsolicitedAnnounce(snatpmp, addr_count);
+#endif
+	}
+#endif
+
 	/* main loop */
 	while(!quitting)
 	{
diff --git a/miniupnpd/pcpserver.c b/miniupnpd/pcpserver.c
index 7930fa56..01b4e7a7 100644
--- a/miniupnpd/pcpserver.c
+++ b/miniupnpd/pcpserver.c
@@ -1637,9 +1637,9 @@ int OpenAndConfPCPv6Socket(void)
 #endif /*ENABLE_IPV6*/
 
 #ifdef ENABLE_IPV6
-static void PCPSendUnsolicitedAnnounce(int * sockets, int n_sockets, int socket6)
+void PCPSendUnsolicitedAnnounce(int * sockets, int n_sockets, int socket6)
 #else /* IPv4 only */
-static void PCPSendUnsolicitedAnnounce(int * sockets, int n_sockets)
+void PCPSendUnsolicitedAnnounce(int * sockets, int n_sockets)
 #endif
 {
 	int i;
diff --git a/miniupnpd/pcpserver.h b/miniupnpd/pcpserver.h
index 3357e4f5..e2ccc7cf 100644
--- a/miniupnpd/pcpserver.h
+++ b/miniupnpd/pcpserver.h
@@ -52,6 +52,14 @@ int ProcessIncomingPCPPacket(int s, unsigned char *msg_buff, int len,
  */
 int OpenAndConfPCPv6Socket(void);
 
+/*
+ * Send Unsolicited ANNOUNCE Message
+ */
+#ifdef ENABLE_IPV6
+void PCPSendUnsolicitedAnnounce(int * sockets, int n_sockets, int socket6);
+#else /* IPv4 only */
+void PCPSendUnsolicitedAnnounce(int * sockets, int n_sockets);
+#endif
 
 /*
  * To be called when Public IP address changed (IPv4)
